#include <jabberd.h>

#define PHASE_SEND 0
#define PHASE_CMD 1
#define PHASE_DATA 2

#define CMD_NONE 0
#define CMD_HELO 1
#define CMD_MAIL 2
#define CMD_RCPT 3
#define CMD_DATA 4
#define CMD_NOOP 5
#define CMD_RSET 6
#define CMD_QUIT 7
#define CMD_DATA2 8

#define MIME_7BIT 0
#define MIME_8BIT 1
#define MIME_BINARY 2
#define MIME_QUOTED 3
#define MIME_BASE64 4

/* smtp parser instance */
typedef struct smtpi_struct
{
    instance i;
    char *server; /* our master server address, if any */
    char *relay; /* the smtp relay delivering our messages for us */
    int timeout; /* how long to wait for an incoming request */
    char *me; /* our default smtp hostname */
    int open; /* if this component is wide open */
    char *spamcheck;
    xmlnode config;
} *smtpi, _smtpi;

/* our 'session' data */
typedef struct smtps_struct
{
    int phase, timer, lastcmd;
    char *from;
    char *buffer;
    char *host;
    spool message;
    jid rcpt;
    mio m;
    pool p;
    xmlnode x;
    smtpi i;
} *smtps, _smtps;

/* context for MIME decoding */
typedef struct mimectx_struct
{
    int mimeUsed;
    int mimeEncoding;
    char *mimeCharset;
} *mimectx, _mimectx;

smtps smtp_new(mio m);
void smtp_in_read(mio m, int state, void *arg, char *buffer,int bufsz);
result smtp_out_packets(instance i, dpacket p, void *arg);

jid smtp_2mx(smtpi i, jid id);
jid smtp_mx2(smtpi i, jid id);

